unit VGridEditor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,Elastic, ComCtrls;

type
  TFrmGrid = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Panel2: TPanel;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BMOD: TBitBtn;
    BitBtn4: TBitBtn;
    VList: TTreeView;
    Label9: TLabel;
    PList: TListBox;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Label10: TLabel;
    Label11: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    SMAN: TSpeedButton;
    SAUTO: TSpeedButton;
    Label12: TLabel;
    Label13: TLabel;
    Edit9: TEdit;
    Edit10: TEdit;
    B7: TBitBtn;
    B8: TBitBtn;
    Label14: TLabel;
    Label15: TLabel;
    Cali: TComboBox;
    ScrollBox1: TScrollBox;
    PGrid: TPaintBox;
    PVS: TShape;
    Label4: TLabel;
    Edit6: TEdit;
    Label7: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Edit4: TEdit;
    procedure BitBtn4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure VListClick(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure PGridPaint(Sender: TObject);
    procedure B7Click(Sender: TObject);
    procedure PGridMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PGridMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PListClick(Sender: TObject);
    procedure BMODClick(Sender: TObject);
    procedure PGridDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure CaliClick(Sender: TObject);
    procedure PGridDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
    Procedure SetElastic ( AElastic  : TElastic );

  public
    { Public declarations }
    AVGridSel   : PVirtualGrid;
    FX          ,
    FY          : Real;
    CLX         ,
    CLY         : Integer;
    FElastic    : TElastic;
    ActualID    : LongInt;
    IsDragMode  ,
    ResLast     ,
    FirstTime   ,
    IsMouseDown : Boolean;
    LastRect    ,
    DrawRect    : TRect;
    Property EditElastic : TElastic Write SetElastic;
  end;

Implementation

Var
  FrmGrid: TFrmGrid;

{$R *.DFM}

Procedure MyVGridCallBack  ( Var AVG : PVirtualGrid );
Var
  C       : Integer;
  PT      : TTreeNode;
  CI      : PVGControlInfo;
  R1      : TRect;
Begin

  R1:=FrmGrid.FElastic.GetVGridRect(AVG,1,1);
  PT:=FrmGrid.VList.Items.AddObject ( Nil,
                                      '['+ IntToStr(AVG^.ID)+']: ('+
                                      IntToStr(AVG^.NumRows)+','+
                                      IntToStr(AVG^.NumCols)+')('+
                                      IntToStr(R1.Left)+','+
                                      IntToStr(R1.Top)+','+
                                      IntToStr(R1.Right-R1.Left)+','+
                                      IntToStr(R1.Bottom-R1.Top)+')',
                                      TObject(AVG));

  For C:=0 To AVG^.ControlList.Count-1 Do
  Begin
    CI:=PVGControlInfo(AVG^.ControlList.Items[C]);
    FrmGrid.VList.Items.AddChildObject (
                                    PT,
                                    FrmGrid.FElastic.Controls[CI^.ControlIndex].Name+': ('+
                                    IntToStr(CI^.NRow)+','+
                                    IntToStr(CI^.NCol)+') '+
                                    FrmGrid.FElastic.Controls[CI^.ControlIndex].ClassName,
                                    TObject(CI));
  End;
End;

Procedure TFrmGrid.SetElastic ( AElastic  : TElastic );
Var
  C : Integer;
Begin
  VList.Items.Clear;
  PList.Items.Clear;
  If AElastic=Nil Then Exit;
  FElastic:=AElastic;
  AElastic.IterateVGrid(MyVGridCallBack);
  PList.Clear;
  For C:=0 To AElastic.ControlCount-1 Do
  Begin
    If Not AElastic.FindCompByIdx(C) Then
      PList.Items.AddObject( AElastic.Controls[C].Name +': '+ AElastic.Controls[C].ClassName,TObject(C));
  End;
(*  PGrid.Height:=FElastic.Height;
  PGrid.Width:=FElastic.Width;*)
  FX:= PGrid.Width / FElastic.Width;
  FY:= PGrid.Height / FElastic.Height ;
  VList.FullExpand;
End;

procedure TFrmGrid.BitBtn4Click(Sender: TObject);
begin
  Close;
end;

procedure TFrmGrid.FormCreate(Sender: TObject);
begin
  FrmGrid:=Self;
  Cali.ItemIndex:=0;
  IsDragMode:=False;
  FirstTime:=False;
end;

procedure TFrmGrid.BitBtn1Click(Sender: TObject);
Var
  Avg : PVirtualGrid;
  R1  : TRect;
begin

  R1:=Rect( StrToInt(Edit3.Text) ,
            StrToInt(Edit4.Text) ,
            StrToInt(Edit5.Text) ,
            StrToInt(Edit6.Text) );

  Avg:=FElastic.AddVGrid ( StrToInt(Edit1.Text),
                           StrToInt(Edit2.Text),
                           R1);

  Case Cali.ItemIndex Of
    0 : Avg^.Align:=alNone;
    1 : Avg^.Align:=alTop;
    2 : Avg^.Align:=alRight;
    3 : Avg^.Align:=alBottom;
    4 : Avg^.Align:=alLeft;
    5 : Avg^.Align:=alClient;
  End;

  PGrid.Invalidate;
  SetElastic ( FElastic );
end;

Procedure PaintGrid( DstCanvas : TCanvas; AVGrid : PVirtualGrid; LC : TColor);
Var
  R1      : TRect;
  RH      ,
  CW      ,
  C       : Integer;
  CI      : PVGControlInfo;
Begin
  With DstCanvas Do
  Begin

    Pen.Color:=LC;
    Brush.Color:=clNavy;
    Brush.Style:=bsSolid;

    R1 := FrmGrid.FElastic.GetVGridRectCR(AVGrid,FrmGrid.FX,FrmGrid.FY,CW,RH);
    Rectangle( R1.Left ,
               R1.Top  ,
               R1.Right,
               R1.Bottom );

    For C:=1 To AVGrid^.NumCols-1 Do
    Begin
      MoveTo ( R1.Left  + CW*C,
               R1.Top );

      LineTo ( R1.Left + CW*C,
               R1.Bottom);
    End;

    For C:=1 To AVGrid^.NumRows-1 Do
    Begin
      MoveTo ( R1.Left ,
               R1.Top  + RH*C);

      LineTo ( R1.Right,
               R1.Top  + RH*C);
    End;

    Pen.Mode:=pmCopy;
    Font.Name:='Arial';
    Font.Size:=-8;
    Font.Color:=clWhite;
    Brush.Color:=clBtnFace;
    For C:=0 To AVGrid^.ControlList.Count-1 Do
    Begin
      CI:=PVGControlInfo(AVGrid^.ControlList.Items[C]);

      R1:=FrmGrid.FElastic.GetCellRect (AVGrid, CI^.NCol, CI^.NRow, FrmGrid.FX,FrmGrid.FY );
      R1.Top:=R1.Top+1;
      R1.Left:=R1.Left+1;
      TextRect( R1,
                R1.Left+ 2,
                R1.Top + (RH - TextHeight('A')) Div 2,
                TLabel(FrmGrid.FElastic.Controls[CI^.ControlIndex]).Caption);
    End;

  End;
End;

Procedure MyPaintVGridCallBack  ( Var AVG : PVirtualGrid );
Begin
  PaintGrid( FrmGrid.PGrid.Canvas, AVG, clWhite );
End;

procedure TFrmGrid.VListClick(Sender: TObject);
Var
  AVGrid : PVirtualGrid;
  ACtrl  : PVGControlInfo;
  R1     : TRect;
  RH      ,
  CW      : Integer;
begin
  BitBtn5.Enabled:=(PList.ItemIndex>=0) And (VList.Selected <> Nil);
  BMOD.Enabled:=VList.Selected <> Nil;
  Cali.Enabled:=VList.Selected <> Nil;

  If VList.Selected = Nil Then Exit;

  Edit7.Text:='1';
  Edit8.Text:='1';
  ACtrl:=Nil;

  If VList.Selected.Parent=Nil Then
  Begin
    AVGrid:=PVirtualGrid(VList.Selected.Data);
    BitBtn6.Enabled:=False;
  End Else
  Begin
    BitBtn6.Enabled:=True;
    AVGrid:=PVirtualGrid(VList.Selected.Parent.Data);
    ACtrl:=PVGControlInfo(VList.Selected.Data);
    Edit7.Text:=IntToStr(ACtrl^.NRow);
    Edit8.Text:=IntToStr(ACtrl^.NCol);
  End;

  ActualID:=AVGrid^.ID;


  Case AVGrid^.Align Of
    alNone   : Cali.ItemIndex:=0;
    alTop    : Cali.ItemIndex:=1;
    alRight  : Cali.ItemIndex:=2;
    alBottom : Cali.ItemIndex:=3;
    alLeft   : Cali.ItemIndex:=4;
    alClient : Cali.ItemIndex:=5;
  End;


  Edit1.Text:=IntToStr(AVGrid^.NumRows);
  Edit2.Text:=IntToStr(AVGrid^.NumCols);

  R1:=FElastic.GetVGridRectCR(AVGrid,FX,FY,CW,RH);
  R1:=FElastic.GetVGridRect(AVGrid,1,1);

  Edit3.Text:=IntToStr(R1.Left);
  Edit4.Text:=IntToStr(R1.Top);
  Edit5.Text:=IntToStr(R1.Right-R1.Left);
  Edit6.Text:=IntToStr(R1.Bottom-R1.Top);

  FElastic.IterateVGrid(MyPaintVGridCallBack);
  PaintGrid( PGrid.Canvas, AVGrid , clYellow);

  If ACtrl<>Nil Then
  Begin
    With PGrid.Canvas Do
    Begin
      Pen.Mode:=pmCopy;
      Font.Name:='Arial';
      Font.Size:=-8;
      Font.Color:=clYellow;
      Brush.Color:=clBtnFace;

      R1:=FElastic.GetCellRect (AVGrid, ACtrl^.NCol, ACtrl^.NRow, FX,FrmGrid.FY );
      R1.Top:=R1.Top+1;
      R1.Left:=R1.Left+1;
      TextRect( R1,
                R1.Left+ 2,
                R1.Top + (RH - TextHeight('A')) Div 2,
                TLabel(FElastic.Controls[ACtrl^.ControlIndex]).Caption);
    End;
  End;
End;


procedure TFrmGrid.BitBtn5Click(Sender: TObject);
Var
  NIdx ,
  VIdx : Integer;
begin
  If PList.Items.Count=0 Then Exit;
  VIdx:=PList.ItemIndex;
  NIdx:=0;
  If SMAN.Down Then
    FElastic.AddControlToVGrid ( PVirtualGrid(VList.Selected.Data)^.ID,
                                 StrToInt(Edit7.Text), StrToInt(Edit8.Text),
                                 LongInt(PList.Items.Objects[PList.ItemIndex]))
  Else
  Begin
    FElastic.AddControlToVGrid ( PVirtualGrid(VList.Selected.Data)^.ID,
                                 StrToInt(Edit9.Text), StrToInt(Edit10.Text),
                                 LongInt(PList.Items.Objects[PList.ItemIndex]));
    If B7.Caption='+' Then
    Begin
      If StrToInt(Edit9.Text)<PVirtualGrid(VList.Selected.Data)^.NumRows Then
        Edit9.Text:=IntToStr(StrToInt(Edit9.Text)+1)
      Else
        Edit9.Text:='1';
    End Else
    If B7.Caption='-' Then
    Begin
      If StrToInt(Edit9.Text)>1 Then
        Edit9.Text:=IntToStr(StrToInt(Edit9.Text)-1)
      Else
        Edit9.Text:=IntToStr(PVirtualGrid(VList.Selected.Data)^.NumRows);
    End;

    If B8.Caption='+' Then
    Begin
      If StrToInt(Edit10.Text)<PVirtualGrid(VList.Selected.Data)^.NumCols Then
        Edit10.Text:=IntToStr(StrToInt(Edit10.Text)+1)
      Else
        Edit10.Text:='1';
    End Else
    If B8.Caption='-' Then
    Begin
      If StrToInt(Edit10.Text)>1 Then
        Edit10.Text:=IntToStr(StrToInt(Edit10.Text)-1)
      Else
        Edit10.Text:=IntToStr(PVirtualGrid(VList.Selected.Data)^.NumCols);
    End;

    If PList.ItemIndex<PList.Items.Count-1 Then
      NIdx:=VIdx
    Else
      NIdx:=0;
  End;
  PList.Items.Delete(VIdx);
  PGrid.Invalidate;
  SetElastic ( FElastic );
  PList.ItemIndex:=NIdx;
end;


procedure TFrmGrid.PGridPaint(Sender: TObject);
Begin
  FElastic.IterateVGrid(MyPaintVGridCallBack);
End;


procedure TFrmGrid.B7Click(Sender: TObject);
begin
  If TSpeedButton(Sender).Caption='0' Then
    TSpeedButton(Sender).Caption:='+'
  Else
  If TSpeedButton(Sender).Caption='+' Then
    TSpeedButton(Sender).Caption:='-'
  Else
    TSpeedButton(Sender).Caption:='0';

end;

procedure TFrmGrid.PGridMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var
  C      : Integer;
begin
  If Button<>mbLeft Then Exit;
  AVGridSel:=FElastic.FindVGridByPos( Point(Trunc(X / FX),Trunc(Y / FY)),Nil,True);
  If AVGridSel<>Nil Then
  Begin
    For C:=0 To VList.Items.Count-1 Do
    Begin
      If PVirtualGrid(VList.Items[C].Data)=AVGridSel Then
      Begin
        VList.Selected:=VList.Items[C];

        PVS.BoundsRect:=FElastic.GetVGridRect ( AVGridSel,FX,FY);
        PVS.Left:=PVS.Left;
        PVS.Top:=PVS.Top;

        LastRect:=PVS.BoundsRect;
        CLX:=X-PVS.Left;
        CLY:=Y-PVS.Top;
        PVS.Visible:=True;
        VListClick(Nil);
      End;
    End;
    Exit;
  End;
  IsMouseDown:=True;
  DrawRect.Left:=X;
  DrawRect.Top:=Y;
  FirstTime:=True;
end;

procedure TFrmGrid.PGridMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var
  AVGrid : PVirtualGrid;
  R1     : TRect;
begin
  Label14.Caption:='X: ' +IntToStr(Trunc(X/FX))+', Y: '+IntToStr(Trunc((Y)/FY));
  If IsDragMode Then Exit;
  If PVS.Visible And (AVGridSel^.Align=alClient) Then Exit;
  If PVS.Visible Then
  Begin
    AVGrid:=FElastic.FindVGridByPos( Point(Trunc(X / FX),Trunc(Y / FY)),AVGridSel,True);
    //LastRect
    If (AVGrid=Nil) Or (AVGrid=AVGridSel) Then
    Begin
      If ResLast Then
      Begin
        PVS.BoundsRect:=LastRect;
        ResLast:=False;
      End;
      Case AVGridSel^.Align Of
        alNone :
        Begin
          PVS.Left:=X-CLX;
          PVS.Top:=Y-CLY;
        End;
        alTop    : PVS.Height:=Y+CLY;
        alBottom :
        Begin
          PVS.Top:=Y-CLY;
          PVS.Height:=PGrid.Height-(Y-CLY);
        End;
        alLeft   : PVS.Width:=X+CLX;
        alRight  :
        Begin
          PVS.Left:=X-CLX;
          PVS.Width:=PGrid.Width-(X-CLX);
        End;
      End;
    End Else
    Begin
     ResLast:=True;
     R1:=FElastic.GetVGridRect ( AVGrid,FX,FY);
     PVS.BoundsRect:=FElastic.GetCellRectAtPos (  AVGrid ,
                                                  X-R1.Left,Y-R1.Top,
                                                  FX,FY);
    End;
    Exit;
  End;

  If Not IsMouseDown Then Exit;
  PGrid.Canvas.Brush.Style:=bsClear;
  PGrid.Canvas.Pen.Mode:=pmXor;
  If Not FirstTime Then
    PGrid.Canvas.Rectangle(DrawRect.Left,DrawRect.Top,DrawRect.Right,DrawRect.Bottom);

  DrawRect.Right:=X;
  DrawRect.Bottom:=Y;
  PGrid.Canvas.Rectangle(DrawRect.Left,DrawRect.Top,DrawRect.Right,DrawRect.Bottom);
  FirstTime:=False;
  //Set Grid

  If DrawRect.Left<=DrawRect.Right Then
  Begin
    Edit3.Text:=IntToStr(Trunc(DrawRect.Left/FX));
    Edit5.Text:=IntToStr(Trunc( (DrawRect.Right-DrawRect.Left)/FX / StrToInt(Edit2.Text) * StrToInt(Edit2.Text) ));
  End Else
  Begin
    Edit3.Text:=IntToStr(Trunc(DrawRect.Right/FX));
    Edit5.Text:=IntToStr(Trunc( (DrawRect.Left-DrawRect.Right)/FX / StrToInt(Edit2.Text) * StrToInt(Edit2.Text) ));
  End;

  If DrawRect.Top<=DrawRect.Bottom Then
  Begin
    Edit4.Text:=IntToStr(Trunc(DrawRect.Top/FY));
    Edit6.Text:=IntToStr(Trunc((DrawRect.Bottom-DrawRect.Top)/FY / StrToInt(Edit1.Text) * StrToInt(Edit1.Text)));
  End Else
  Begin
    Edit4.Text:=IntToStr(Trunc(DrawRect.Bottom/FY));
    Edit6.Text:=IntToStr(Trunc((DrawRect.Top-DrawRect.Bottom)/FY / StrToInt(Edit1.Text) * StrToInt(Edit1.Text)));
  End;
end;

procedure TFrmGrid.PGridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  If PVS.Visible Then
  Begin
    Case AVGridSel^.Align Of
      alNone :
      Begin
        AVGridSel^.BoundsRect.Left:=Trunc(PVS.Left  / FX)+1;
        AVGridSel^.BoundsRect.Top:=Trunc(PVS.Top  / FY)+1;
        AVGridSel^.BoundsRect.Right:=Trunc(PVS.Width  / FX);
        AVGridSel^.BoundsRect.Bottom:=Trunc(PVS.Height  / FY);
      End;
      alTop    : AVGridSel^.BoundsRect.Bottom:=Trunc(PVS.Height  / FY);
      alBottom :
      Begin
        AVGridSel^.BoundsRect.Top:=Trunc(PVS.Top  / FY)+1;
        AVGridSel^.BoundsRect.Bottom:=Trunc(PVS.Height  / FY);
      End;
      alLeft   : AVGridSel^.BoundsRect.Right:=Trunc(PVS.Width  / FX);
      alRight  :
      Begin
        AVGridSel^.BoundsRect.Left:=Trunc(PVS.Left  / FX)+1;
        AVGridSel^.BoundsRect.Right:=Trunc(PVS.Width  / FX);
      End;
    End;

    PGrid.Invalidate;
    SetElastic ( FElastic );
    PVS.Visible:=False;
    Exit;
  End;

  If (Button<>mbLeft) Or Not IsMouseDown Then Exit;
  IsMouseDown:=False;
  PGrid.Canvas.Pen.Mode:=pmXor;
  If Not FirstTime Then
    PGrid.Canvas.Rectangle(DrawRect.Left,DrawRect.Top,DrawRect.Right,DrawRect.Bottom);
  PGrid.Canvas.Pen.Mode:=pmCopy;
  //Add Grid
  BitBtn1Click(Nil);
end;

procedure TFrmGrid.PListClick(Sender: TObject);
begin
  BitBtn5.Enabled:=(PList.ItemIndex>=0) And (VList.Selected <> Nil);
end;

Procedure TFrmGrid.BMODClick(Sender: TObject);
Var
  Avg : PVirtualGrid;
  R1  : TRect;
begin
  If VList.Selected=Nil Then Exit;
  
  R1:=Rect( StrToInt(Edit3.Text) ,
            StrToInt(Edit4.Text) ,
            StrToInt(Edit5.Text) ,
            StrToInt(Edit6.Text) );

  If VList.Selected.Parent=Nil Then
    Avg:=PVirtualGrid(VList.Selected.Data)
  Else
    Avg:=PVirtualGrid(VList.Selected.Parent.Data);

  Avg^.NumRows:=StrToInt(Edit1.Text);
  Avg^.NumCols:=StrToInt(Edit2.Text);
  Avg^.BoundsRect:=R1;

  PGrid.Invalidate;
  SetElastic ( FElastic );
end;

procedure TFrmGrid.PGridDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
Var
  Avg : PVirtualGrid;
  R1  : TRect;
begin
  IsDragMode:=True;
  Avg:=FElastic.FindVGridByPos( Point(Trunc(X / FX),Trunc(Y / FY)),Nil,True);
  Accept:=(Avg<>Nil);
  PVS.Visible:=Accept;
  If Not Accept Then Exit;
  R1:=FElastic.GetVGridRect ( Avg,FX,FY);

  R1:=FElastic.GetCellRectAtPos (  Avg ,
                                               X-R1.Left,Y-R1.Top,
                                               FX,FY);
  R1.Top:=R1.Top+2;
  R1.Left:=R1.Left+2;
  R1.Right:=R1.Right+1;
  R1.Bottom:=R1.Bottom+1;
  PVS.BoundsRect:=R1;
End;


procedure TFrmGrid.CaliClick(Sender: TObject);
Var
  Avg : PVirtualGrid;
begin
  If VList.Selected=Nil Then
  Begin
    Cali.Enabled:=False;
    Exit;
  End;
  If VList.Selected.Parent=Nil Then
    Avg:=PVirtualGrid(VList.Selected.Data)
  Else
    Avg:=PVirtualGrid(VList.Selected.Parent.Data);
  Case Cali.ItemIndex Of
    0 : Avg^.Align:=alNone;
    1 : Avg^.Align:=alTop;
    2 : Avg^.Align:=alRight;
    3 : Avg^.Align:=alBottom;
    4 : Avg^.Align:=alLeft;
    5 : Avg^.Align:=alClient;
  End;
  PGrid.Invalidate;
  SetElastic ( FElastic );
end;

procedure TFrmGrid.PGridDragDrop(Sender, Source: TObject; X, Y: Integer);
Var
  CC      ,
  RR      : Integer;
  Avg     : PVirtualGrid;
  R1      : TRect;
begin
  PVS.Visible:=False;
  IsDragMode:=False;
  Avg:=FElastic.FindVGridByPos( Point(Trunc(X / FX),Trunc(Y / FY)),Nil,True);
  If Avg=Nil Then Exit;
  R1:=FrmGrid.FElastic.GetVGridRect(Avg,FX,FY);
  FElastic.GetCellAtPos  (Avg, X-R1.Left, Y-R1.Top ,FX,FY,CC,RR);
  FElastic.AddControlToVGrid ( Avg^.ID,
                               RR, CC,
                               LongInt(PList.Items.Objects[PList.ItemIndex]));
  PGrid.Invalidate;
  SetElastic ( FElastic );
end;




procedure TFrmGrid.BitBtn6Click(Sender: TObject);
begin
  FElastic.RemoveControlFromVG ( FElastic.Controls[PVGControlInfo(FrmGrid.VList.Selected.Data)^.ControlIndex] );
  PGrid.Invalidate;
  SetElastic ( FElastic );
end;

procedure TFrmGrid.BitBtn2Click(Sender: TObject);
begin
  If VList.Selected=Nil Then Exit;
  If VList.Selected.Parent=Nil Then
    FElastic.RemoveVGByIdx (PVirtualGrid(VList.Selected.Data)^.ID)
  Else
    FElastic.RemoveVGByIdx (PVirtualGrid(VList.Selected.Parent.Data)^.ID);
  PGrid.Invalidate;
  SetElastic ( FElastic );
end;

End.
